package cn.timer.api.bean.zpgl;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.*;
import java.util.Date;



/**
 * 招聘管理人才信息表
 * 
 * @author wuqingjun
 * @email 284718418@qq.com
 * @date 2022-03-08 15:14:40
 */
@Entity
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "zpgl_rcxx")
@Data
public class ZpglRcxx extends Model<ZpglRcxx> {
	private static final long serialVersionUID = 1L;
	/**
	 * 主键ID
	 */
	@Id
	@GeneratedValue
	@TableId(type = IdType.AUTO)
	@ApiModelProperty(value = "编号")
	private Integer id;
	/**
	* 职位id
	*/
	@ApiModelProperty(value = "职位id")
	private Integer zpglZwxxId;
	/**
	* 姓名
	*/
	@ApiModelProperty(value = "姓名")
	private String name;
	/**
	* 手机
	*/
	@ApiModelProperty(value = "手机")
	private String mobile;
	/**
	* 邮件地址
	*/
	@ApiModelProperty(value = "邮件地址")
	private String mail;
	/**
	* 身份证号码
	*/
	@ApiModelProperty(value = "身份证号码")
	private String idCard;
	/**
	* 微信
	*/
	@ApiModelProperty(value = "微信")
	private String weixin;
	/**
	* 身高CM
	*/
	@ApiModelProperty(value = "身高CM")
	private Integer height;
	/**
	* 体重KG
	*/
	@ApiModelProperty(value = "体重KG")
	private Integer weight;
	/**
	* 政治面貌
	*/
	@ApiModelProperty(value = "政治面貌")
	private String face;
	/**
	* 民族
	*/
	@ApiModelProperty(value = "民族")
	private Integer nationClassId;
	/**
	 * 籍贯
	 */
	@ApiModelProperty(value = "籍贯")
	private String nativePlace;
	/**
	 * 部门岗位ID
	 */
	@ApiModelProperty(value = "部门岗位ID")
	private Integer bmgwId;
	/**
	 * 工作性质 0全职、1实习、2兼职、3劳务派遣、4劳务、5派遣、6外包、7退休返聘
	 */
	@ApiModelProperty(value = "工作性质 0全职、1实习、2兼职、3劳务派遣、4劳务、5派遣、6外包、7退休返聘")
	private Integer jobType;
	/**
	 * 预计入职日期
	 */
	@ApiModelProperty(value = "预计入职日期")
	private Date yjrzTime;
	/**
	 * 省名
	 */
	@ApiModelProperty(value = "省名")
	private String provinceId;
	/**
	 * 省名
	 */
	@ApiModelProperty(value = "省名")
	private String province;
	/**
	 * 区名
	 */
	@ApiModelProperty(value = "区名")
	private String districtId;
	/**
	 * 区名
	 */
	@ApiModelProperty(value = "区名")
	private String district;
	/**
	 * 城市
	 */
	@ApiModelProperty(value = "城市")
	private String cityId;
	/**
	 * 城市
	 */
	@ApiModelProperty(value = "城市")
	private String city;
	/**
	 * 详细地址
	 */
	@ApiModelProperty(value = "详细地址")
	private String address;

	/**
	 * 现居住地详址
	 */
	@ApiModelProperty(value = "现居住地详址")
	private String grAddress;


	/**
	* 是否结婚：0否，1是
	*/
	@ApiModelProperty(value = "是否结婚：0否，1是")
	private Integer marryStatus;
	/**
	* 语言 1:英语 2:粤语 3:普通话
	 * 列：1,2,3
	*/
	@ApiModelProperty(value = "语言 1:英语 2:粤语 3:普通话 ")
	private String language;
	/**
	* 驾照 1:A照 2:B照 3:C照
	*/
	@ApiModelProperty(value = "驾照 1:A照 2:B照 3:C照")
	private Integer drivingLicense;
	/**
	 * 病史 ：0无，1有
	 */
	@ApiModelProperty(value = "病史 ：0无，1有")
	private Integer medicalHistory;
	/**
	 * 病史1有：具体说明
	 */
	@ApiModelProperty(value = "具体说明")
	private String medicalDetail;
	/**
	* 待遇要求（税前）单位元/月
	*/
	@ApiModelProperty(value = "待遇要求（税前）单位元/月")
	private Integer salary;
	/**
	* 求职状态：0离职，1在岗
	*/
	@ApiModelProperty(value = "求职状态：0离职，1在岗")
	private Integer workStatus;
	/**
	* 可到岗时间：0一周内 1两周内 2一个月内 3两个月内 4不确定
	*/
	@ApiModelProperty(value = "可到岗时间：0一周内 1两周内 2一个月内 3两个月内 4不确定")
	private Integer workTimer;
	/**
	* 爱好特长
	*/
	@ApiModelProperty(value = "爱好特长")
	private String hobby;
	/**
	* 受到奖励
	*/
	@ApiModelProperty(value = "受到奖励")
	private String reward;
	/**
	* 处分，违法，犯罪记录
	*/
	@ApiModelProperty(value = "处分，违法，犯罪记录")
	private String record;
	/**
	* 招聘渠道ID
	*/
	@ApiModelProperty(value = "招聘渠道ID")
	private Integer zpglZpqdId;

	/**
	 * 签名图片
	 */
	@ApiModelProperty(value = "签名图片")
	private String signatureImg;

	/**
	* 文件名
	*/
	@ApiModelProperty(value = "文件名")
	private String fileName;
	/**
	* 文件路径
	*/
	@ApiModelProperty(value = "文件路径")
	private String filePath;
	/**
	* 备注
	*/
	@ApiModelProperty(value = "备注")
	private String remarks;
	/**
	* 性别 0：男1：女
	*/
	@ApiModelProperty(value = "性别 0：男1：女")
	private Integer sex;
	/**
	* 出生日期
	*/
	@ApiModelProperty(value = "出生日期")
	private Date datebirth;
	/**
	* 工作年限
	*/
	@ApiModelProperty(value = "工作年限")
	private Integer workyears;
	/**
	* 最高学历 1:小学;2:初中;3:高中;4:中专;5:大专;6:本科;7:研究生;8:硕士;9:博士
	*/
	@ApiModelProperty(value = "最高学历 1:小学;2:初中;3:高中;4:中专;5:大专;6:本科;7:研究生;8:硕士;9:博士")
	private String highesteducation;
	/**
	 * 毕业院校
	 */
	@ApiModelProperty(value = "毕业院校")
	private String universitie;
	/**
	 * 专业名称
	 */
	@ApiModelProperty(value = "专业名称")
	private String subject;
	/**
	* 最近工作单位
	*/
	@ApiModelProperty(value = "最近工作单位")
	private String company;

	/**
	 * 最近职位
	 */
	@ApiModelProperty(value = "最近职位")
	private String zjzw;


	/**
	 * 参加工作时间
	 */
	@ApiModelProperty(value = "参加工作时间")
	private Date workBeginYear;


	/**
	* 标签
	*/
	@ApiModelProperty(value = "标签")
	private String label;
	/**
	* 状态 1:待初筛 2:初筛通过 3:已安排面试 4:已面试 5:面试通过 6:拟录用 7:已发Offer 8:待入职 9已淘汰 10已入职
	*/
	@ApiModelProperty(value = "状态 1:待初筛 2:初筛通过 3:已安排面试 4:已面试 5:面试通过 6:拟录用 7:已发Offer 8:待入职 9已淘汰 10已入职")
	private Integer status;
	/**
	* 对应淘汰原因字典ID
	*/
	@ApiModelProperty(value = "对应淘汰原因字典ID")
	private Integer zpglFailId;
	/**
	 * 对应合同公司字典ID
	 */
	@ApiModelProperty(value = "对应合同公司字典ID")
	private Integer zpglCompanyId;
	/**
	 * 对应职级字典ID
	 */
	@ApiModelProperty(value = "对应职级字典ID")
	private Integer zpglZjId;
	/**
	 * 对应工作地点字典ID
	 */
	@ApiModelProperty(value = "对应工作地点字典ID")
	private Integer zpglGzddId;
	/**
	* 面试官id
	*/
	@ApiModelProperty(value = "面试官id")
	private Integer interviewerId;
	/**
	* 面试时间
	*/
	@ApiModelProperty(value = "面试时间")
	private Date interviewTime;
	/**
	 * 面试方式 1:现场面试 2:电话面试 3:视屏面试
	 */
	@ApiModelProperty(value = "面试方式 1:现场面试 2:电话面试 3:视屏面试")
	private Integer interviewWay;
	/**
	* 通知方式 1:全部 2:短信 3:邮件 4.微信公众号
	*/
	@ApiModelProperty(value = "通知方式 1:全部 2:短信 3:邮件 4.微信公众号")
	private Integer noticeWay;
	/**
	* 面试轮次
	*/
	@ApiModelProperty(value = "面试轮次")
	private Integer interviewNum;
	/**
	* 对应用户id
	*/
	@ApiModelProperty(value = "对应用户id")
	private Integer userId;
	/**
	* 加入原因
	*/
	@ApiModelProperty(value = "加入原因")
	private String joincause;
	/**
	* 组织机构代码
	*/
	@ApiModelProperty(value = "组织机构代码")
	private String orgCode;
	/**
	* 创建时间
	*/
	@ApiModelProperty(value = "创建时间")
	private Date createTime;
	/**
	 * 更新时间
	 */
	@ApiModelProperty(value = "更新时间")
	private Date updateTime;
	/**
	 * 国家地区 0:中国;1:中国香港;2:中国澳门;3:中国台湾
	 */
	@ApiModelProperty(value = "国家地区 0:中国;1:中国香港;2:中国澳门;3:中国台湾")
	private Integer area;
	/**
	 * 附加操作：0无，1加入人才库
	 */
	@ApiModelProperty(value = "附加操作：0无，1加入人才库")
	private Integer ifrck;
	/**
	 * 附加操作：0无，1加入人才库
	 */
	@ApiModelProperty(value = "附加操作：0无，1加入人才库")
	private Date ifrckTime;
	/**
	 * 逻辑删除标记0.未删除 1.删除
	 */
	@ApiModelProperty(value = "逻辑删除标记0.未删除 1.删除")
	private Integer deleteFlag;

	/**
	 * 淘汰原因
	 */
	@Transient
	@TableField(exist = false)
	@ApiModelProperty(value = "淘汰原因")
	private String failCause;

}
