package cn.timer.api.dto.zpgl;

import cn.timer.api.bean.zpgl.ZpglRcxxExperience;
import cn.timer.api.bean.zpgl.ZpglRcxxJtzl;
import cn.timer.api.bean.zpgl.ZpglRcxxLxxxb;
import cn.timer.api.bean.zpgl.ZpglRcxxStudy;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.validation.constraints.NotEmpty;
import java.io.Serializable;
import java.util.Date;
import java.util.List;

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class InterviewApplicationDto implements Serializable {


    /**
     * 人才信息ID
     */
    @ApiModelProperty(value = "人才信息ID")
    private Integer id;
    /**
     * 组织机构代码
     */
    @ApiModelProperty(value = "组织机构代码")
    private String orgCode;

    /**
     * 状态 1:待初筛 2:初筛通过 3:已安排面试 4:已面试 5:面试通过 6:拟录用 7:已发Offer 8:待入职 9已淘汰 10已入职
     */
    @ApiModelProperty(value = "状态 1:待初筛 2:初筛通过 3:已安排面试 4:已面试 5:面试通过 6:拟录用 7:已发Offer 8:待入职 9已淘汰 10已入职")
    private Integer status;

    /**
     * 姓名
     */
    @NotEmpty(message = "姓名号为空")
    @ApiModelProperty(value = "姓名")
    private String name;
    /**
     * 手机
     */
    @NotEmpty(message = "手机号为空")
    @ApiModelProperty(value = "手机")
    private String mobile;
    /**
     * 邮件地址
     */
    @ApiModelProperty(value = "邮件地址")
    private String mail;
    /**
     * 身份证号码
     */
    @ApiModelProperty(value = "身份证号码")
    private String idCard;
    /**
     * 性别 1：男2：女
     */
    @ApiModelProperty(value = "性别 1：男2：女")
    private Integer sex;
    /**
     * 微信
     */
    @ApiModelProperty(value = "微信")
    private String weixin;
    /**
     * 身高CM
     */
    @ApiModelProperty(value = "身高CM")
    private Integer height;
    /**
     * 体重KG
     */
    @ApiModelProperty(value = "体重KG")
    private Integer weight;
    /**
     * 政治面貌
     */
    @ApiModelProperty(value = "政治面貌")
    private String face;
    /**
     * 民族
     */
    @ApiModelProperty(value = "民族")
    private Integer nationClassId;

    /**
     * 籍贯
     */
    @ApiModelProperty(value = "籍贯")
    private String nativePlace;
    /**
     * 最高学历 1:小学;2:初中;3:高中;4:中专;5:大专;6:本科;7:研究生;8:硕士;9:博士
     */
    @ApiModelProperty(value = "最高学历 1:小学;2:初中;3:高中;4:中专;5:大专;6:本科;7:研究生;8:硕士;9:博士")
    private String highesteducation;


    /**
     * 省名id
     */
    @ApiModelProperty(value = "省名id")
    private String provinceId;
    /**
     * 省名
     */
    @ApiModelProperty(value = "省名")
    private String province;
    /**
     * 区名id
     */
    @ApiModelProperty(value = "区名id")
    private String districtId;
    /**
     * 区名
     */
    @ApiModelProperty(value = "区名")
    private String district;
    /**
     * 城市id
     */
    @ApiModelProperty(value = "城市id")
    private String cityId;
    /**
     * 城市
     */
    @ApiModelProperty(value = "城市")
    private String city;
    /**
     * 详细地址
     */
    @ApiModelProperty(value = "详细地址")
    private String address;

    /**
     * 现居住地详址
     */
    @ApiModelProperty(value = "现居住地详址")
    private String grAddress;

    /**
     * 是否结婚：0否，1是
     */
    @ApiModelProperty(value = "是否结婚：0否，1是")
    private Integer marryStatus;
    /**
     * 语言 1:英语 2:粤语 3:普通话
     * 列：1,2,3
     */
    @ApiModelProperty(value = "语言 1:英语 2:粤语 3:普通话 ")
    private String language;
    /**
     * 驾照 1:A照 2:B照 3:C照
     */
    @ApiModelProperty(value = "驾照 1:A照 2:B照 3:C照")
    private Integer drivingLicense;
    /**
     * 病史 ：0无，1有
     */
    @ApiModelProperty(value = "病史 ：0无，1有")
    private Integer medicalHistory;

    /**
     * 病史1有：具体说明
     */
    @ApiModelProperty(value = "具体说明")
    private String medicalDetail;

    /**
     * 最近工作单位
     */
    @ApiModelProperty(value = "最近工作单位")
    private String company;

    /**
     * 毕业院校
     */
    @ApiModelProperty(value = "毕业院校")
    private String universitie;

    /**
     * 专业名称
     */
    @ApiModelProperty(value = "专业名称")
    private String subject;

    /**
     * 最近职位
     */
    @ApiModelProperty(value = "最近职位")
    private String zjzw;

    /**
     * 参加工作时间
     */
    @ApiModelProperty(value = "参加工作时间")
    private Date workBeginYear;

    /**
     * 待遇要求（税前）单位元/月
     */
    @ApiModelProperty(value = "待遇要求（税前）单位元/月")
    private Integer salary;
    /**
     * 求职状态：0离职，1在岗
     */
    @ApiModelProperty(value = "求职状态：0离职，1在岗")
    private Integer workStatus;
    /**
     * 可到岗时间：0一周内 1两周内 2一个月内 3两个月内 4不确定
     */
    @ApiModelProperty(value = "可到岗时间：0一周内 1两周内 2一个月内 3两个月内 4不确定")
    private Integer workTimer;

    /**
     * 爱好特长
     */
    @ApiModelProperty(value = "爱好特长")
    private String hobby;
    /**
     * 受到奖励
     */
    @ApiModelProperty(value = "受到奖励")
    private String reward;
    /**
     * 处分，违法，犯罪记录
     */
    @ApiModelProperty(value = "处分，违法，犯罪记录")
    private String record;
    /**
     * 招聘渠道ID
     */
    @ApiModelProperty(value = "招聘渠道ID")
    private Integer zpglZpqdId;

    /**
     * 签名图片
     */
    @ApiModelProperty(value = "签名图片")
    private String signatureImg;

    /**
     * 职位信息ID
     */
    @ApiModelProperty(value = "职位信息ID")
    private Integer zpglZwxxId;
    /**
     * 联系人信息
     */
    @ApiModelProperty(value = "联系人信息")
    private ZpglRcxxLxxxb zpglRcxxLxxxb;

    /**
     * 工作经验
     */
    @ApiModelProperty(value = "工作经验")
    private List<ZpglRcxxExperience> zpglRcxxExperience;

    /**
     * 教育经历
     */
    @ApiModelProperty(value = "教育经历")
    private List<ZpglRcxxStudy> zpglRcxxStudy;

    /**
     * 家庭资料
     */
    @ApiModelProperty(value = "家庭资料")
    private List<ZpglRcxxJtzl> zpglRcxxJtzls;



}
