package cn.timer.api.dto.zpgl;

import cn.timer.api.bean.disk.DiskCloudDiskUser;
import cn.timer.api.config.exception.ValidationMsg;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 * @author wuqingjun
 * @email 284718418@qq.com
 * @date 2021-12-27 10:05:49
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class ZpglRcxxDto implements Serializable{
	
	private static final long serialVersionUID = -1230023773946171911L;

	/**
	 * 人才信息Id
	 */
	@ApiModelProperty(value = "人才信息Id")
	private Integer id;

	/**
	 * 状态 1:待初筛 2:初筛通过 3:已安排面试 4:已面试 5:面试通过 6:拟录用 7:已发Offer 8:待入职 9已淘汰 10已入职
	 */
	@ApiModelProperty(value = "状态 1:待初筛 2:初筛通过 3:已安排面试 4:已面试 5:面试通过 6:拟录用 7:已发Offer 8:待入职 9已淘汰 10已入职")
	private Integer status;

	/**
	 * 资源目录ID
	 */
	@ApiModelProperty(value = "淘汰原因ID")
	private Integer zpglFailId;
	/**
	 * 职位id
	 */
	@ApiModelProperty(value = "职位id")
	private Integer zpglZwxxId;
	/**
	 * 备注
	 */
	@ApiModelProperty(value = "备注")
	private String remarks;
	/**
	 * 姓名
	 */
	@ApiModelProperty(value = "姓名")
	private String name;
	/**
	 * 附加操作：0无，1加入人才库
	 */
	@ApiModelProperty(value = "附加操作：0无，1加入人才库")
	private Integer ifrck;

	/**
	 * 面试轮次 12345
	 */
	@ApiModelProperty(value = "面试轮次 12345")
	private Integer interviewNum;

	/**
	 * 面试方式 1:现场面试 2:电话面试 3:视屏面试
	 */
	@ApiModelProperty(value = "面试方式 1:现场面试 2:电话面试 3:视屏面试")
	private Integer interviewWay;
	/**
	 * 面试官id
	 */
	@ApiModelProperty(value = "面试官id")
	private Integer interviewerId;
	/**
	 * 面试时间
	 */
	@ApiModelProperty(value = "面试时间")
	private Date interviewTime;

	/**
	 * 通知方式 1:全部 2:短信 3:邮件 4.微信公众号
	 */
	@ApiModelProperty(value = "通知方式 1:全部 2:短信 3:邮件 4.微信公众号")
	private Integer noticeWay;
	/**
	 * 部门岗位ID
	 */
	@ApiModelProperty(value = "部门岗位ID")
	private Integer bmgwId;
	/**
	 * 工作性质 0全职、1实习、2兼职、3劳务派遣、4劳务、5派遣、6外包、7退休返聘
	 */
	@ApiModelProperty(value = "工作性质 0全职、1实习、2兼职、3劳务派遣、4劳务、5派遣、6外包、7退休返聘")
	private Integer jobType;
	/**
	 * 预计入职日期
	 */
	@ApiModelProperty(value = "预计入职日期")
	private Date yjrzTime;

	/**
	 * 联系人id
	 */
	@ApiModelProperty(value = "联系人id")
	private Integer linkId;

}
